/*
  AntiRight
  (c) 2003-2004 Jeffrey Bedard
  jefbed@e-list.net
   
  This file is part of AntiRight.
   
  AntiRight is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
   
  AntiRight is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
   
  You should have received a copy of the GNU General Public License
  along with AntiRight; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "arshell.h"

void
arshell_system_cb(Widget parent_widget,
		  XtPointer client_data,
		  XtPointer call_data)
{
  antiright_system(client_data);
  
  if(arshell_exit_on_action_flag)
    exit(0);

  parent_widget=(Widget)NULL;
  call_data=(XtPointer)NULL;
}
void
arshell_update(char* command_string)
{
  char* input_string;
  
  input_string=antiright_pipe_read(command_string);
  input_string[strlen(input_string)-1]='\0';
  antiright_status(input_string);
  free(input_string);
}
void
arshell_update_work_procedure(XtPointer client_data,
			      XtIntervalId* timer_id)
{  
  arshell_update(client_data);
  *timer_id=
    XtAppAddTimeOut(app_context,
		    1000, /* 1 second.  */
		    arshell_update_work_procedure,
		    client_data);
}

void
arshell_beautify_label(Widget widget, 
		       char* current_argument_string)
{
  char *label_string=antiright_beautified_label(current_argument_string);
  antiright_label_string(widget, label_string);
  free(label_string);
}

void
arshell_set_rows(int* counter_int, 
		 char** argv,
		 int* rows_int, 
		 int* row_counter_int)
{
  (*counter_int)++;
  *rows_int=atoi(argv[(*counter_int)]);
  row_counter_int=rows_int;
}

void
arshell_row_layout(Widget mainwindow_widget,
		   Widget* row_manager_widget, 
		   Widget* row_widget, 
		   int* row_counter_int,
		   int rows_int)
{  
  if((*row_counter_int)==0)
    {
      if((*row_manager_widget) == NULL)
	{
	  ARCLARG;
	  antiright_set(XmNorientation, XmHORIZONTAL);
	  (*row_manager_widget)=antiright_row(mainwindow_widget);
	}
      ARCLARG;
      antiright_set(XmNorientation, XmVERTICAL);
      (*row_widget)=antiright_row((*row_manager_widget));
      (*row_counter_int)=rows_int;
    }
  (*row_counter_int)--;
}

void
arshell_usage()
{
  antiright_standard_usage("arshell");
  puts("\t[-Ep]\n\t[-A[[C][l label][m[fevh] label][s][t label][w]]"
       "\n\t[-r rows]\n\t[-U command]\n\t[-W title]\n\t[button]\n");
  antiright_report_bugs_message();
  exit(1);
}

Widget
arshell_optioned_button(Widget parent_widget,
			XtCallbackProc callback,
			char* command_string)
{
  Widget button_widget=XmCreatePushButton(parent_widget,
					  command_string,
					  antiright_arguments,
					  antiright_number_arguments);
  XtManageChild(button_widget);
  XtAddCallback(button_widget,
		XmNactivateCallback,
		callback,
		command_string);
  arshell_beautify_label(button_widget, command_string);
  return(button_widget);
}
